/*
   The function MaxSubArray() is a solution to the maximum-subarray
   problem from Section 4.1 of CLRS.

   This solution runs in linear time, that is, its O(n).
*/
#include <stdlib.h>
#include <limits.h>


typedef struct{
   int sum;
   int low;
   int high;
} ReturnType;


ReturnType* MaxSubArray(int* a, int low, int high)
{
   ReturnType * returnValue;
   int sum, maxSum, maxLow, maxHigh, leftIndex;
   int i;

   maxSum = a[low];
   maxLow = low;
   maxHigh = low;
   sum = a[low];
   leftIndex = low;
   for (i = low+1; i <= high; i++)
   {
      if (sum > 0)
      {
         sum += a[i];
      }
      else
      {
         sum = a[i];
         leftIndex = i;
      }
      if (sum > maxSum)
      {
         maxSum = sum;
         maxLow = leftIndex;
         maxHigh = i;
      }
   }

   // allocate, populate, and return a value
   returnValue = (ReturnType*)malloc( sizeof(ReturnType) );
   returnValue->sum = maxSum;
   returnValue->low = maxLow;
   returnValue->high = maxHigh;
   return returnValue;
}
