/*
   The function MaxSubArray() is a solution to the maximum-subarray
   problem from Section 4.1 of CLRS.

   This solution runs in quadratic time, that is, its O(n^2).
*/
#include <stdlib.h>
#include <limits.h>


typedef struct{
   int sum;
   int low;
   int high;
} ReturnType;


ReturnType* MaxSubArray(int* a, int low, int high)
{
   ReturnType * returnValue;
   int sum, maxSum, maxLow, maxHigh;
   int i, j;

   maxSum = INT_MIN;
   for (i = low; i < high; i++)
   {
      sum = 0;
      for (j = i; j <= high; j++)
      {
         sum += a[j];
         if (sum > maxSum)
         {
            maxSum = sum;
            maxLow = i;
            maxHigh = j;
         }
      }
   }

   // allocate, populate, and return a value
   returnValue = (ReturnType*)malloc( sizeof(ReturnType) );
   returnValue->sum = maxSum;
   returnValue->low = maxLow;
   returnValue->high = maxHigh;
   return returnValue;
}

/*
   There is a BIG, but subtle, error in this program.
   What is it?
*/
